#line 1 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Amaury/Visual TFT Projects/joystick_emulator/joystick_Code/mikroC PRO for PIC32/joystick_driver.c"
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/amaury/visual tft projects/joystick_emulator/joystick_code/mikroc pro for pic32/joystick_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef const struct CButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 const char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCButton;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int CButtonsCount;
 TCButton * const code *CButtons;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
};

extern TScreen Screen1;
extern TCButton Button1;
extern TCButton Button2;
extern TCButton Button3;
extern TCButton Button4;
extern TCButton Button5;
extern TCButton Button6;
extern TCButton Button7;
extern TCButton Button8;
extern TCButton Button9;
extern TCButton Button10;
extern TBox Box1;
extern TCButton * const code Screen1_CButtons[10];
extern TBox * const code Screen1_Boxes[1];




void Box1OnClick();
void Box1OnDown();
void Box1OnPress();
void Button10OnClick();
void Button10OnDown();
void Button10OnUp();
void Button1OnDown();
void Button1OnUp();
void Button2OnClick();
void Button2OnDown();
void Button2OnUp();
void Button3OnClick();
void Button3OnDown();
void Button3OnUp();
void Button4OnClick();
void Button4OnDown();
void Button4OnUp();
void Button5OnClick();
void Button5OnDown();
void Button5OnUp();
void Button6OnClick();
void Button6OnDown();
void Button6OnUp();
void Button7OnClick();
void Button7OnDown();
void Button7OnUp();
void Button8OnClick();
void Button8OnDown();
void Button8OnUp();
void Button9OnClick();
void Button9OnDown();
void Button9OnUp();
void ButtonUpOnUp();
void ButtonUpOnDown();
void ButtonDownOnUp();
void ButtonDownOnDown();
void ButtonLeftOnUp();
void ButtonLeftOnDown();
void ButtonRightOnUp();
void ButtonRightOnDown();




extern const char Button1_Caption[];
extern const char Button2_Caption[];
extern const char Button3_Caption[];
extern const char Button4_Caption[];
extern const char Button5_Caption[];
extern const char Button6_Caption[];
extern const char Button7_Caption[];
extern const char Button8_Caption[];
extern const char Button9_Caption[];
extern const char Button10_Caption[];
extern const char ButtonUp_Caption[];
extern const char ButtonDown_Caption[];
extern const char ButtonLeft_Caption[];
extern const char ButtonRight_Caption[];
extern char Box1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawCButton(TCButton *aCButton);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/amaury/visual tft projects/joystick_emulator/joystick_code/mikroc pro for pic32/joystick_resources.h"
const code char Tahoma11x13_Regular[];
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/amaury/visual tft projects/joystick_emulator/joystick_code/mikroc pro for pic32/joystick_main.h"
typedef union {
 char bytes[6];
 struct {
 char x_value;
 char y_value;
 char rx_value;
 char ry_value;
 unsigned pov_hat :4;
 unsigned button_1 :1;
 unsigned button_2 :1;
 unsigned button_3 :1;
 unsigned button_4 :1;
 unsigned button_5 :1;
 unsigned button_6 :1;
 unsigned button_7 :1;
 unsigned button_8 :1;
 unsigned button_9 :1;
 unsigned button_10:1;
 unsigned button_11:1;
 unsigned button_12:1;
 };
} T_USB_Report;

extern T_USB_Report USB_Report;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 8 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Amaury/Visual TFT Projects/joystick_emulator/joystick_Code/mikroC PRO for PIC32/joystick_driver.c"
char TFT_DataPort at LATE;
sbit TFT_RST at LATC1_bit;
sbit TFT_BLED at LATA9_bit;
sbit TFT_RS at LATB15_bit;
sbit TFT_CS at LATF12_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
char TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISC1_bit;
sbit TFT_BLED_Direction at TRISA9_bit;
sbit TFT_RS_Direction at TRISB15_bit;
sbit TFT_CS_Direction at TRISF12_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;



sbit DriveX_Left at LATB13_bit;
sbit DriveX_Right at LATB11_bit;
sbit DriveY_Up at LATB12_bit;
sbit DriveY_Down at LATB10_bit;
sbit DriveX_Left_Direction at TRISB13_bit;
sbit DriveX_Right_Direction at TRISB11_bit;
sbit DriveY_Up_Direction at TRISB12_bit;
sbit DriveY_Down_Direction at TRISB10_bit;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1000;
char PenDown;
typedef unsigned long TPointer;
TPointer PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TCButton *local_cbutton;
TCButton *exec_cbutton;
int cbutton_order;
TBox *local_box;
TBox *exec_box;
int box_order;

void PMPWaitBusy() {
 while(PMMODEbits.BUSY);
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 PMDIN = index;
 PMPWaitBusy();
}

void Write_Command( unsigned short cmd ) {
 TFT_RS = 1;
 PMDIN = cmd;
 PMPWaitBusy();
}

void Write_Data(unsigned int _data) {
 TFT_RS = 1;
 PMDIN = _data;
 PMPWaitBusy();
}


void Init_ADC() {
 AD1PCFG = 0xFFFF;
 PCFG12_bit = 0;
 PCFG13_bit = 0;

 ADC1_Init();
}
static void InitializeTouchPanel() {
 Init_ADC();
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init(320, 240);

 TP_TFT_Init(320, 240, 13, 12);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TCButton Button1 =
 {
 &Screen1 ,
 0 ,
 202 ,
 55 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button1_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button1OnUp ,
 Button1OnDown ,
 0 ,
 0
 };
const char Button1_Caption[2] = "1";

 TCButton Button2 =
 {
 &Screen1 ,
 1 ,
 202 ,
 80 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button2_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button2OnUp ,
 Button2OnDown ,
 0 ,
 0
 };
const char Button2_Caption[2] = "2";

 TCButton Button3 =
 {
 &Screen1 ,
 2 ,
 202 ,
 105 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button3_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button3OnUp ,
 Button3OnDown ,
 0 ,
 0
 };
const char Button3_Caption[2] = "3";

 TCButton Button4 =
 {
 &Screen1 ,
 3 ,
 202 ,
 130 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button4_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button4OnUp ,
 Button4OnDown ,
 0 ,
 0
 };
const char Button4_Caption[2] = "4";

 TCButton Button5 =
 {
 &Screen1 ,
 4 ,
 202 ,
 155 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button5_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button5OnUp ,
 Button5OnDown ,
 0 ,
 0
 };
const char Button5_Caption[2] = "5";

 TCButton Button6 =
 {
 &Screen1 ,
 5 ,
 252 ,
 55 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button6_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button6OnUp ,
 Button6OnDown ,
 0 ,
 0
 };
const char Button6_Caption[2] = "6";

 TCButton Button7 =
 {
 &Screen1 ,
 6 ,
 252 ,
 80 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button7_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button7OnUp ,
 Button7OnDown ,
 0 ,
 0
 };
const char Button7_Caption[2] = "7";

 TCButton Button8 =
 {
 &Screen1 ,
 7 ,
 252 ,
 105 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button8_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button8OnUp ,
 Button8OnDown ,
 0 ,
 0
 };
const char Button8_Caption[2] = "8";

 TCButton Button9 =
 {
 &Screen1 ,
 8 ,
 252 ,
 130 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button9_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button9OnUp ,
 Button9OnDown ,
 0 ,
 0
 };
const char Button9_Caption[2] = "9";

 TCButton Button10 =
 {
 &Screen1 ,
 9 ,
 252 ,
 155 ,
 50 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &Button10_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 Button10OnUp ,
 Button10OnDown ,
 0 ,
 0
 };
const char Button10_Caption[3] = "10";

 TCButton ButtonUp =
 {
 &Screen1 ,
 11 ,
 145 ,
 182 ,
 30 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &ButtonUp_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 ButtonUpOnUp ,
 ButtonUpOnDown ,
 0 ,
 0
 };
const char ButtonUp_Caption[3] = "Up";

 TCButton ButtonDown =
 {
 &Screen1 ,
 12 ,
 145 ,
 212 ,
 30 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &ButtonDown_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 ButtonDownOnUp ,
 ButtonDownOnDown ,
 0 ,
 0
 };
const char ButtonDown_Caption[5] = "Down";

 TCButton ButtonLeft =
 {
 &Screen1 ,
 13 ,
 110 ,
 200 ,
 30 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &ButtonLeft_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 ButtonLeftOnUp ,
 ButtonLeftOnDown ,
 0 ,
 0
 };
const char ButtonLeft_Caption[5] = "Left";

 TCButton ButtonRight =
 {
 &Screen1 ,
 14 ,
 180 ,
 200 ,
 30 ,
 25 ,
 1 ,
 0x0000 ,
 1 ,
 1 ,
 1 ,
 &ButtonRight_Caption ,
 _taCenter ,
 &Tahoma11x13_Regular ,
 0x0000 ,
 1 ,
 0 ,
 0xFFFF ,
 0xC618 ,
 0xC618 ,
 1 ,
 0xE71C ,
 ButtonRightOnUp ,
 ButtonRightOnDown ,
 0 ,
 0
 };
const char ButtonRight_Caption[6] = "Right";

 TBox Box1;
 TCButton * const code Screen1_CButtons[14]=
 {
 &Button1,
 &Button2,
 &Button3,
 &Button4,
 &Button5,
 &Button6,
 &Button7,
 &Button8,
 &Button9,
 &Button10,
 &ButtonUp,
 &ButtonDown,
 &ButtonLeft,
 &ButtonRight
 };
 TBox * const code Screen1_Boxes[1]=
 {
 &Box1
 };



static void InitializeObjects() {
 Screen1.Color = 0xFFFF;
 Screen1.Width = 320;
 Screen1.Height = 240;
 Screen1.CButtonsCount = 14;
 Screen1.CButtons = Screen1_CButtons;
 Screen1.BoxesCount = 1;
 Screen1.Boxes = Screen1_Boxes;
 Screen1.ObjectsCount = 15;


 Box1.OwnerScreen = &Screen1;
 Box1.Order = 10;
 Box1.Left = 32;
 Box1.Top = 51;
 Box1.Width = 128;
 Box1.Height = 128;
 Box1.Pen_Width = 1;
 Box1.Pen_Color = 0x0000;
 Box1.Visible = 1;
 Box1.Active = 1;
 Box1.Transparent = 1;
 Box1.Gradient = 0;
 Box1.Gradient_Orientation = 0;
 Box1.Gradient_Start_Color = 0xFFFF;
 Box1.Gradient_End_Color = 0xC618;
 Box1.Color = 0xD69A;
 Box1.PressColEnabled = 1;
 Box1.Press_Color = 0xE71C;
 Box1.OnUpPtr = 0;
 Box1.OnDownPtr = 0;
 Box1.OnClickPtr = 0;
 Box1.OnPressPtr = Box1OnPress;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}






void DrawCButton(TCButton *Abutton) {
 if (Abutton->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
 }
 TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
 TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
 TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
 if (Abutton->TextAlign == _taLeft)
 TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 else if (Abutton->TextAlign == _taCenter)
 TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 else if (Abutton->TextAlign == _taRight)
 TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
 }
}

void DrawBox(TBox *ABox) {
 if (ABox->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
 }
 TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
 TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short cbutton_idx;
 TCButton *local_cbutton;
 unsigned short box_idx;
 TBox *local_box;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 cbutton_idx = 0;
 box_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 save_bled_direction = TFT_BLED_Direction;
 TFT_BLED_Direction = 0;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
 TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 13, 12);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 TFT_BLED_Direction = save_bled_direction;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (cbutton_idx < CurrentScreen->CButtonsCount) {
 local_cbutton =  CurrentScreen->CButtons[cbutton_idx] ;
 if (order == local_cbutton->Order) {
 cbutton_idx++;
 order++;
 DrawCButton(local_cbutton);
 }
 }

 if (box_idx < CurrentScreen->BoxesCount) {
 local_box =  CurrentScreen->Boxes[box_idx] ;
 if (order == local_box->Order) {
 box_idx++;
 order++;
 DrawBox(local_box);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 cbutton_order = -1;
 box_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->CButtonsCount ; _object_count++ ) {
 local_cbutton =  CurrentScreen->CButtons[_object_count] ;
 if (local_cbutton->Active == 1) {
 if (IsInsideObject(X, Y, local_cbutton->Left, local_cbutton->Top,
 local_cbutton->Width, local_cbutton->Height) == 1) {
 cbutton_order = local_cbutton->Order;
 exec_cbutton = local_cbutton;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->BoxesCount ; _object_count++ ) {
 local_box =  CurrentScreen->Boxes[_object_count] ;
 if (local_box->Active == 1) {
 if (IsInsideObject(X, Y, local_box->Left, local_box->Top,
 local_box->Width, local_box->Height) == 1) {
 box_order = local_box->Order;
 exec_box = local_box;
 }
 }
 }

 _object_count = -1;
 if (cbutton_order > _object_count )
 _object_count = cbutton_order;
 if (box_order > _object_count )
 _object_count = box_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_cbutton = 0;
 exec_box = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == cbutton_order) {
 if (exec_cbutton->Active == 1) {
 if (exec_cbutton->OnPressPtr != 0) {
 exec_cbutton->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == box_order) {
 if (exec_box->Active == 1) {
 if (exec_box->OnPressPtr != 0) {
 exec_box->OnPressPtr();
 return;
 }
 }
 }

 }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 8: {
 if (PressedObject != 0) {
 exec_cbutton = (TCButton*)PressedObject;
 if ((exec_cbutton->PressColEnabled == 1) && (exec_cbutton->OwnerScreen == CurrentScreen)) {
 DrawCButton(exec_cbutton);
 }
 break;
 }
 break;
 }

 case 6: {
 if (PressedObject != 0) {
 exec_box = (TBox*)PressedObject;
 if ((exec_box->PressColEnabled == 1) && (exec_box->OwnerScreen == CurrentScreen)) {
 DrawBox(exec_box);
 }
 break;
 }
 break;
 }
 }


 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == cbutton_order) {
 if (exec_cbutton->Active == 1) {
 if (exec_cbutton->OnUpPtr != 0)
 exec_cbutton->OnUpPtr();
 if (PressedObject == (TPointer)exec_cbutton)
 if (exec_cbutton->OnClickPtr != 0)
 exec_cbutton->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == box_order) {
 if (exec_box->Active == 1) {
 if (exec_box->OnUpPtr != 0)
 exec_box->OnUpPtr();
 if (PressedObject == (TPointer)exec_box)
 if (exec_box->OnClickPtr != 0)
 exec_box->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_cbutton = 0;
 exec_box = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == cbutton_order) {
 if (exec_cbutton->Active == 1) {
 if (exec_cbutton->PressColEnabled == 1) {
 object_pressed = 1;
 DrawCButton(exec_cbutton);
 }
 PressedObject = (TPointer)exec_cbutton;
 PressedObjectType = 8;
 if (exec_cbutton->OnDownPtr != 0) {
 exec_cbutton->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == box_order) {
 if (exec_box->Active == 1) {
 if (exec_box->PressColEnabled == 1) {
 object_pressed = 1;
 DrawBox(exec_box);
 }
 PressedObject = (TPointer)exec_box;
 PressedObjectType = 6;
 if (exec_box->OnDownPtr != 0) {
 exec_box->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (TP_TFT_Press_Detect()) {

 if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
 else {
 USB_Report.y_value = 0;
 USB_Report.x_value = 0;
 }
}

void Init_MCU() {
 PMMODE = 0;
 PMAEN = 0;
 PMCON = 0;
 PMMODEbits.MODE = 2;
 PMMODEbits.WAITB = 0;
 PMMODEbits.WAITM = 1;
 PMMODEbits.WAITE = 0;
 PMMODEbits.MODE16 = 1;
 PMCONbits.CSF = 0;
 PMCONbits.PTRDEN = 1;
 PMCONbits.PTWREN = 1;
 PMCONbits.PMPEN = 1;
 TFT_Set_Default_Mode();
 TP_TFT_Set_Default_Mode();
 TFT_Set_Active(Set_Index,Write_Command,Write_Data);
}

void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();


 TP_TFT_Set_Calibration_Consts(76, 907, 77, 915);

 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
