/*
 * Project name:
     joystick.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     14/06/2013
 * Time of creation
     14:06:56
 * Test configuration:
     MCU:             P32MX460F512L
     Dev.Board:       MikroMMB_for_PIC32_hw_rev_1.10
                      http://www.mikroe.com/mikromedia/pic32/
     Oscillator:      80000000 Hz
     SW:              mikroC PRO for PIC32
                      http://www.mikroe.com/mikroc/pic32/
 */

#include "joystick_objects.h"
#include "joystick_main.h"
#include "USB_DSC.c"

#define USB_BUFFER_LEN       64

unsigned char readbuff[USB_BUFFER_LEN] ;
unsigned char writebuff[USB_BUFFER_LEN] ;

T_USB_Report USB_Report;

void ViderBuffer(char * buffer, unsigned int buffer_len) {
     unsigned int cpt = 0;
     for (cpt=0; cpt<buffer_len; cpt++) *(buffer+cpt) = 0;
}

void USB_Isr() iv IVT_USB_1 ilevel 7 ics ICS_SRS {
     USB_Interrupt_Proc();        // USB servicing is done inside the interrupt
     USBIF_bit = 0;
}

void Tmr1_isr() iv IVT_TIMER_1 ilevel 4 ics ICS_SOFT
{
    Check_TP();
    T1IF_bit = 0;  //acquite l'IT
}

void main() {

  unsigned char i = 0;
  unsigned long int old_report_raw = 0;
  
  ViderBuffer(USB_Report.bytes, sizeof(USB_Report));

  //Paramtrage Timer 1
  TMR1 = 0;                 // reset timer value to zero
  PR1 = 0.01 * (80000000. / 256.);                 // Load period register IT TMR1 toutes les 0.1 s
  
   //Priorit IT Timer 1
  T1IP0_bit = 0;            // set interrupt
  T1IP1_bit = 0;            // priority
  T1IP2_bit = 1;            // to 4
  
  // Prescaler Timer 1
  T1CONbits.TCKPS0 = 1;           // Set Timer 1 Input Clock
  T1CONbits.TCKPS1 = 1;           // Prescale value to 1:256
  
  EnableInterrupts();

  USBIP0_bit = 1;
  USBIP1_bit = 1;
  USBIP2_bit = 1;
  USBIE_bit = 1;
  
  USB_Report.pov_hat = 4;
  
  HID_Enable(&readbuff,&writebuff);


  Start_TP();
  // Activation IT Timer 1
  T1IE_bit = 1;             // Enable Timer1 Interrupt
  // Mise en route Timer 1
  ON__T1CON_bit = 1;        // Enable Timer1

  while (1) {
    HID_Write(USB_Report.bytes, sizeof(USB_Report));
  }
}