#line 1 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Amaury/Visual TFT Projects/joystick_emulator/joystick_Code/mikroC PRO for PIC32/joystick_main.c"
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/amaury/visual tft projects/joystick_emulator/joystick_code/mikroc pro for pic32/joystick_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef const struct CButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 const char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCButton;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int CButtonsCount;
 TCButton * const code *CButtons;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
};

extern TScreen Screen1;
extern TCButton Button1;
extern TCButton Button2;
extern TCButton Button3;
extern TCButton Button4;
extern TCButton Button5;
extern TCButton Button6;
extern TCButton Button7;
extern TCButton Button8;
extern TCButton Button9;
extern TCButton Button10;
extern TBox Box1;
extern TCButton * const code Screen1_CButtons[10];
extern TBox * const code Screen1_Boxes[1];




void Box1OnClick();
void Box1OnDown();
void Box1OnPress();
void Button10OnClick();
void Button10OnDown();
void Button10OnUp();
void Button1OnDown();
void Button1OnUp();
void Button2OnClick();
void Button2OnDown();
void Button2OnUp();
void Button3OnClick();
void Button3OnDown();
void Button3OnUp();
void Button4OnClick();
void Button4OnDown();
void Button4OnUp();
void Button5OnClick();
void Button5OnDown();
void Button5OnUp();
void Button6OnClick();
void Button6OnDown();
void Button6OnUp();
void Button7OnClick();
void Button7OnDown();
void Button7OnUp();
void Button8OnClick();
void Button8OnDown();
void Button8OnUp();
void Button9OnClick();
void Button9OnDown();
void Button9OnUp();
void ButtonUpOnUp();
void ButtonUpOnDown();
void ButtonDownOnUp();
void ButtonDownOnDown();
void ButtonLeftOnUp();
void ButtonLeftOnDown();
void ButtonRightOnUp();
void ButtonRightOnDown();




extern const char Button1_Caption[];
extern const char Button2_Caption[];
extern const char Button3_Caption[];
extern const char Button4_Caption[];
extern const char Button5_Caption[];
extern const char Button6_Caption[];
extern const char Button7_Caption[];
extern const char Button8_Caption[];
extern const char Button9_Caption[];
extern const char Button10_Caption[];
extern const char ButtonUp_Caption[];
extern const char ButtonDown_Caption[];
extern const char ButtonLeft_Caption[];
extern const char ButtonRight_Caption[];
extern char Box1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawCButton(TCButton *aCButton);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/amaury/visual tft projects/joystick_emulator/joystick_code/mikroc pro for pic32/joystick_main.h"
typedef union {
 char bytes[6];
 struct {
 char x_value;
 char y_value;
 char rx_value;
 char ry_value;
 unsigned pov_hat :4;
 unsigned button_1 :1;
 unsigned button_2 :1;
 unsigned button_3 :1;
 unsigned button_4 :1;
 unsigned button_5 :1;
 unsigned button_6 :1;
 unsigned button_7 :1;
 unsigned button_8 :1;
 unsigned button_9 :1;
 unsigned button_10:1;
 unsigned button_11:1;
 unsigned button_12:1;
 };
} T_USB_Report;

extern T_USB_Report USB_Report;
#line 1 "c:/users/laurent amaury/dropbox/microcontroleurs/amaury/visual tft projects/joystick_emulator/joystick_code/mikroc pro for pic32/usb_dsc.c"
const unsigned int USB_VENDOR_ID = 0x003F;
const unsigned int USB_PRODUCT_ID = 0x04D8;
const char USB_SELF_POWER = 0x80;
const char USB_MAX_POWER = 50;
const char HID_INPUT_REPORT_BYTES = 64;
const char HID_OUTPUT_REPORT_BYTES = 64;
const char USB_TRANSFER_TYPE = 0x03;
const char EP_IN_INTERVAL = 1;
const char EP_OUT_INTERVAL = 1;

const char USB_INTERRUPT = 1;
const char USB_HID_EP = 1;
const char USB_HID_RPT_SIZE = 73;


const struct {
 char bLength;
 char bDescriptorType;
 unsigned int bcdUSB;
 char bDeviceClass;
 char bDeviceSubClass;
 char bDeviceProtocol;
 char bMaxPacketSize0;
 unsigned int idVendor;
 unsigned int idProduct;
 unsigned int bcdDevice;
 char iManufacturer;
 char iProduct;
 char iSerialNumber;
 char bNumConfigurations;
} device_dsc = {
 0x12,
 0x01,
 0x0200,
 0x00,
 0x00,
 0x00,
 8,
 USB_VENDOR_ID,
 USB_PRODUCT_ID,
 0x0001,
 0x01,
 0x02,
 0x00,
 0x01
 };


const char configDescriptor1[]= {

 0x09,
 0x02,
 0x29,0x00,
 1,
 1,
 0,
 USB_SELF_POWER,
 USB_MAX_POWER,


 0x09,
 0x04,
 0,
 0,
 2,
 0x03,
 0,
 0,
 0,


 0x09,
 0x21,
 0x01,0x01,
 0x00,
 1,
 0x22,
 USB_HID_RPT_SIZE,0x00,


 0x07,
 0x05,
 USB_HID_EP | 0x80,
 USB_TRANSFER_TYPE,
 0x40,0x00,
 EP_IN_INTERVAL,


 0x07,
 0x05,
 USB_HID_EP,
 USB_TRANSFER_TYPE,
 0x40,0x00,
 EP_OUT_INTERVAL
};

const struct {
 char report[USB_HID_RPT_SIZE];
}hid_rpt_desc =
 {
 0x05, 0x01,
 0x15, 0x00,
 0x09, 0x04,
 0xa1, 0x01,
 0x05, 0x01,
 0x09, 0x01,
 0xa1, 0x00,
 0x09, 0x30,
 0x09, 0x31,
 0x09, 0x33,
 0x09, 0x34,
 0x25, 0x7f,
 0x15, 0x80,
 0x75, 0x08,
 0x95, 0x04,
 0x81, 0x02,
 0xc0,
 0x09, 0x39,
 0x15, 0x00,
 0x25, 0x03,
 0x35, 0x00,
 0x46, 0x0e, 0x01,
 0x65, 0x14,
 0x75, 0x04,
 0x95, 0x01,
 0x81, 0x02,
 0x05, 0x09,
 0x19, 0x00,
 0x29, 0x0c,
 0x15, 0x00,
 0x25, 0x01,
 0x75, 0x01,
 0x95, 0x0c,
 0x55, 0x00,
 0x65, 0x00,
 0x81, 0x02,
 0xc0
 };


const struct {
 char bLength;
 char bDscType;
 unsigned int string[1];
 } strd1 = {
 4,
 0x03,
 {0x0409}
 };



const struct{
 char bLength;
 char bDscType;
 unsigned int string[14];
 }strd2={
 30,
 0x03,
 {'A','m','a','u','r','y',' ','L','A','U','R','E','N','T'}
 };


const struct{
 char bLength;
 char bDscType;
 unsigned int string[12];
}strd3={
 26,
 0x03,
 {'N','6','4',' ','E','m','u','l','a','t','o','r'}
 };


const char* USB_config_dsc_ptr[1];


const char* USB_string_dsc_ptr[3];

void USB_Init_Desc(){
 USB_config_dsc_ptr[0] = &configDescriptor1;
 USB_string_dsc_ptr[0] = (const char*)&strd1;
 USB_string_dsc_ptr[1] = (const char*)&strd2;
 USB_string_dsc_ptr[2] = (const char*)&strd3;
}
#line 25 "C:/Users/LAURENT Amaury/Dropbox/Microcontroleurs/Amaury/Visual TFT Projects/joystick_emulator/joystick_Code/mikroC PRO for PIC32/joystick_main.c"
unsigned char readbuff[ 64 ] ;
unsigned char writebuff[ 64 ] ;

T_USB_Report USB_Report;

void ViderBuffer(char * buffer, unsigned int buffer_len) {
 unsigned int cpt = 0;
 for (cpt=0; cpt<buffer_len; cpt++) *(buffer+cpt) = 0;
}

void USB_Isr() iv IVT_USB_1 ilevel 7 ics ICS_SRS {
 USB_Interrupt_Proc();
 USBIF_bit = 0;
}

void Tmr1_isr() iv IVT_TIMER_1 ilevel 4 ics ICS_SOFT
{
 Check_TP();
 T1IF_bit = 0;
}

void main() {

 unsigned char i = 0;
 unsigned long int old_report_raw = 0;

 ViderBuffer(USB_Report.bytes, sizeof(USB_Report));


 TMR1 = 0;
 PR1 = 0.01 * (80000000. / 256.);


 T1IP0_bit = 0;
 T1IP1_bit = 0;
 T1IP2_bit = 1;


 T1CONbits.TCKPS0 = 1;
 T1CONbits.TCKPS1 = 1;

 EnableInterrupts();

 USBIP0_bit = 1;
 USBIP1_bit = 1;
 USBIP2_bit = 1;
 USBIE_bit = 1;

 USB_Report.pov_hat = 4;

 HID_Enable(&readbuff,&writebuff);


 Start_TP();

 T1IE_bit = 1;

 ON__T1CON_bit = 1;

 while (1) {
 HID_Write(USB_Report.bytes, sizeof(USB_Report));
 }
}
