typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef const struct  CButton {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  const char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCButton;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int         ObjectsCount;
  unsigned int           CButtonsCount;
  TCButton               * const code *CButtons;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
};

extern   TScreen                Screen1;
extern   TCButton                Button1;
extern   TCButton                Button2;
extern   TCButton                Button3;
extern   TCButton                Button4;
extern   TCButton                Button5;
extern   TCButton                Button6;
extern   TCButton                Button7;
extern   TCButton                Button8;
extern   TCButton                Button9;
extern   TCButton                Button10;
extern   TBox                   Box1;
extern   TCButton               * const code Screen1_CButtons[10];
extern   TBox                   * const code Screen1_Boxes[1];


/////////////////////////
// Events Code Declarations
void Box1OnClick();
void Box1OnDown();
void Box1OnPress();
void Button10OnClick();
void Button10OnDown();
void Button10OnUp();
void Button1OnDown();
void Button1OnUp();
void Button2OnClick();
void Button2OnDown();
void Button2OnUp();
void Button3OnClick();
void Button3OnDown();
void Button3OnUp();
void Button4OnClick();
void Button4OnDown();
void Button4OnUp();
void Button5OnClick();
void Button5OnDown();
void Button5OnUp();
void Button6OnClick();
void Button6OnDown();
void Button6OnUp();
void Button7OnClick();
void Button7OnDown();
void Button7OnUp();
void Button8OnClick();
void Button8OnDown();
void Button8OnUp();
void Button9OnClick();
void Button9OnDown();
void Button9OnUp();
void ButtonUpOnUp();
void ButtonUpOnDown();
void ButtonDownOnUp();
void ButtonDownOnDown();
void ButtonLeftOnUp();
void ButtonLeftOnDown();
void ButtonRightOnUp();
void ButtonRightOnDown();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern const char Button1_Caption[];
extern const char Button2_Caption[];
extern const char Button3_Caption[];
extern const char Button4_Caption[];
extern const char Button5_Caption[];
extern const char Button6_Caption[];
extern const char Button7_Caption[];
extern const char Button8_Caption[];
extern const char Button9_Caption[];
extern const char Button10_Caption[];
extern const char ButtonUp_Caption[];
extern const char ButtonDown_Caption[];
extern const char ButtonLeft_Caption[];
extern const char ButtonRight_Caption[];
extern char Box1_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawCButton(TCButton *aCButton);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();